package de.renew.database.entitylayer;

import java.sql.*;

/**
 * The entity class for the table TOKEN_POSITION.
 */
public class TokenPositionEntity extends Entity
{
	// Table specifications

	/**
	 * The attributes of the entity.
	 */
	private static Attribute[] attributes;

	/**
	 * The primary key of the entity.
	 */
	private static Attribute[] primaryKey;

	static
	{
		primaryKey = new Attribute[]
		{
			new Attribute("TOKEN_ID", Attribute.TYPE_CHAR),
			new Attribute("NET_INSTANCE_ID", Attribute.TYPE_CHAR),
			new Attribute("PLACE_INSTANCE_ID", Attribute.TYPE_INT),
		};

		attributes = new Attribute[]
		{
			new Attribute("TOKEN_ID", Attribute.TYPE_CHAR),
			new Attribute("NET_INSTANCE_ID", Attribute.TYPE_CHAR),
			new Attribute("PLACE_INSTANCE_ID", Attribute.TYPE_INT),
			new Attribute("QUANTITY", Attribute.TYPE_INT)
		};
	}

	/**
	 * Creates the entity.
	 * @param connection The connection to
	 * be used for entity operations.
	 * @param dialect The SQL dialect to
	 * be used for entity operations.
	 */
	public TokenPositionEntity(Connection connection, SQLDialect dialect)
	{
		super(connection, dialect);
	}

	/**
	 * Returns all attributes of the entity as array.
	 * @param All attributes as array.
	 */
	public Attribute[] getAttributes()
	{
		return attributes;
	}

	/**
	 * Returns the primary key attributes of the entity.
	 * @return The primary key attributes.
	 */
	public Attribute[] getPrimaryKey()
	{
		return primaryKey;
	}

	/**
	 * Returns the entity's table name.
	 * @return The entity's table name.
	 */
	public String getTableName()
	{
		return "TOKEN_POSITION";
	}

	// Attribute getter methods

	/**
	 * Returns the value of the attribute TOKEN_ID.
	 * @return The value of the attribute TOKEN_ID.
	 */
	public String getTokenId()
	{
		return (String) getValue("TOKEN_ID");
	}

	/**
	 * Returns the value of the attribute NET_INSTANCE_ID.
	 * @return The value of the attribute NET_INSTANCE_ID.
	 */
	public String getNetInstanceId()
	{
		return (String) getValue("NET_INSTANCE_ID");
	}

	/**
	 * Returns the value of the attribute PLACE_INSTANCE_ID.
	 * @return The value of the attribute PLACE_INSTANCE_ID.
	 */
	public Integer getPlaceInstanceId()
	{
		return (Integer) getValue("PLACE_INSTANCE_ID");
	}

	/**
	 * Returns the value of the attribute QUANTITY.
	 * @return The value of the attribute QUANTITY.
	 */
	public Integer getQuantity()
	{
		return (Integer) getValue("QUANTITY");
	}

	// Attribute setter methods

	/**
	 * Sets the value of the attribute TOKEN_ID.
	 * @param tokenId The new value for the attribute.
	 */
	public void setTokenId(String tokenId)
	{
		setValue("TOKEN_ID", tokenId);
	}

	/**
	 * Sets the value of the attribute NET_INSTANCE_ID.
	 * @param netInstanceId The new value for the attribute.
	 */
	public void setNetInstanceId(String netInstanceId)
	{
		setValue("NET_INSTANCE_ID", netInstanceId);
	}

	/**
	 * Sets the value of the attribute PLACE_INSTANCE_ID.
	 * @param placeInstanceId The new value for the attribute.
	 */
	public void setPlaceInstanceId(Integer placeInstanceId)
	{
		setValue("PLACE_INSTANCE_ID", placeInstanceId);
	}

	/**
	 * Sets the value of the attribute QUANTITY.
	 * @param quantity The new value for the attribute.
	 */
	public void setQuantity(Integer quantity)
	{
		setValue("QUANTITY", quantity);
	}
}
